/*
 * (c) Copyright 2010 by Volker Bergmann. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, is permitted under the terms of the
 * GNU General Public License (GPL).
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * WITHOUT A WARRANTY OF ANY KIND. ALL EXPRESS OR IMPLIED CONDITIONS,
 * REPRESENTATIONS AND WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE
 * HEREBY EXCLUDED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

package org.databene.dbsanity.parser;

import org.databene.dbsanity.model.SanityCheckFile;
import org.databene.dbsanity.model.db.DbsPackage;
import org.w3c.dom.Element;

/**
 * Parses a &lt;package&gt; element in a DB Sanity XML file.<br/><br/>
 * Created: 05.12.2010 10:59:09
 * @since 0.4
 * @author Volker Bergmann
 */
public class PackageParser extends DbSanityXMLParser {

	public PackageParser() {
		super("package", DbsPackage.class, SanityCheckFile.class);
	}

	public Object parse(Element element, Object[] parentPath, DbSanityParseContext context) {
		throw new UnsupportedOperationException(getClass().getName() + ".parse() is not yet implemented");
/*
		assertElementName("package", element);
		String packageName = parseRequiredName(element);
		DbsPackage pkg = new DbsPackage(packageName);
		
		// parse parent
		Object parent = parent(parentPath);
		if (parent instanceof DbsPackage)
			((DbsPackage) parent).addPackage(pkg);
		else {
			String parentName = getOptionalAttribute("parent", element);
			if (parentName != null) {
				DbsPackage parentPackage = context.getDbModel().getPackage(parentName);
				parentPackage.addPackage(pkg);
			} else
				context.getDbModel().addPackage(pkg);
		}
		
		// parse sequence pattern
		String sequencePattern = getOptionalAttribute("sequence-pattern", element);
		pkg.setSequencePattern(sequencePattern);
		
		// parse unimportant columns
		String csl = getOptionalAttribute("unimportant-columns", element);
		if (csl != null) {
			String[] columns = csl.split("\\.");
			pkg.setIrrelevantColumns(CollectionUtil.toSet(columns));
		}
		
		// parse sub packages and tables
		context.parseChildElementsOf(element, pkg, parentPath);
		
		return pkg;
*/
	}

}
