package org.databene.dbsanity.db;

/**
 * Represents a database 'package' which groups tables but does not necessarily 
 * relate to a physical grouping in the database and is supposed to be 
 * defined in a configuration file.  
 * @since 1.0
 * @author Björn Kellermann
 */
public class DbPackage extends AbstractDbPackage {

	protected AbstractDbPackage parent;

	public DbPackage(String name, AbstractDbPackage parent) {
		super(name);
		this.parent = parent;
	}
	
	
}
